Viewing Issue Advanced Details
ID Category [?] Severity [?] Reproducibility Date Submitted Last Update
07072 Known Issues/To-Do's Minor Always Aug 9, 2018, 21:27 Aug 13, 2018, 14:17
Tester ballyalley View Status Public Platform MAME (Official Binary)
Assigned To Resolution Open OS Windows Vista/7/8 (64-bit)
Status [?] Acknowledged Driver astrohome.cpp
Version 0.200 Fixed in Version Build 64-bit
Summary MESS-specific 07072: astrocde and clones: [Enhancement] 2000-Baud "AstroBASIC" Tape I/O Support Missing
Description To follow up on my original report @ http://mametesters.org/view.php?id=6987 :

Here I am focusing on the missing 2000-baud interface that is included in the 1981 re-release of Bally BASIC (also known as "Astrovision BASIC," or, more commonly, "AstroBASIC"). However, it's worth noting that the Astrocade emulator lacks any tape I/O support at all. This means that none of the many hundreds of programs released on tape, or available as type-in programs from various sources, can be used in the Astrocade emulator in MAME.

This report is specifically addressing the missing 2000-baud interface support, but it's important to have a general understanding of all three tape interfaces for the Astrocade.

1) "AstroBASIC" Tape Interface - The "AstroBASIC" cartridge has a built-in tape interface with one 1/8" jack for connection to a tape recorder/player. This interface saves and loads at 2000-baud. This allows a complete 4KB program to fill all of RAM in about twenty seconds. Using a special program included with the Bally BASIC manual, this interface can also be used to load 300-baud tapes so that they can then be saved in the 2000-baud format.

2) Bally Audio Cassette Interface - This external box plugs into joystick port 3 and the accessory jack of the Astrocade. This interface saves at 300-baud and uses (from what I understand) the Kansas City Format. The original Bally BASIC requires this audio interface to save and load programs. Other software that uses this tape interface are: Blue Ram BASIC (optional), Vipersoft BASIC (required), Color BASIC (prototype), Machine Language Manager

3) Blue Ram Hardware Internal Tape Interface - The very rare Blue Ram expansion RAM plugs into the 50-pin edge connector. It has a built-in 2000-baud tape interface. MAME does support this extended RAM, but not the I/O of the upgrade.

The "AstroBASIC" 2000-baud tape interface should get top priority for added support to MAME for several reasons:

"AstroBASIC" shipped with the 1981-rerelease of the Astrocade. Therefore, this is the most-common cartridge for the Astrocade home console. Anyone who bought the Astrocade system in early 1981, or later, got "AstroBASIC" for free with their purchase, while many others, who used the early release of BASIC that required, upgraded to this much-improved version of BASIC. By a very wide margin, most software for the Astrocade was released in the 2000-baud format. Most of the software released in the earlier 300-baud format was re-released in 2000-baud format.

The AstroBASIC cartridge looks like this:
http://www.ballyalley.com/pics/cartridge_pics/Carts_(Astrocade-Bally)/full_size/Astro%20BASIC%20(Bally).jpg

Instructions for using AstroBASIC's built-in audio interface with a tape recorder are on page 15 of the "Bally BASIC" user manual:
http://www.ballyalley.com/basic/Astro_BASIC_Manual_(instructions)(bally)(color)(300%20dpi).pdf#page=17

The BASIC commands required to use the tape interface are detailed in the BASIC manual, but here is a summary of the six commands:
:PRINT - Save a BASIC program
:INPUT - Load a BASIC program
:LIST - Verify a BASIC program
:RUN - Load a machine language program
:PRINT @(0),100 - Saves blocks of data
:INPUT @(0),100 - Loads blocks of data

A schematic for AstroBASIC Audio Tape Interface is available here:
http://www.ballyalley.com/documentation/misc_hardware_docs/Bally/full_size/AstroBASIC_Audio_Tape_Interface_Schematic_(Richard_Degler).pdf

There is also an alternate schematic available in ARCADIAN 4, no. 3 (Dec. 24, 1981): 28
http://www.ballyalley.com/newsletters/arcadian/arcadian_vol_4/arcadian_vol_4_issue_03.pdf#page=6

I have about a 30-minute video which covers how to use "AstroBASIC." It's called "Overview, Review and How to Use Bally BASIC /'AstroBASI' for Bally Arcade/Astrocade." About halfway through the video, I show you how to load a WAV file from a phone (which is simulating a tape player). You can watch the video here:


"AstroWAV" and "BallyBin," by Bob Colbert (written between 2002-2007), will digitally archive 2000-baud analog tapes. This software is available in the tape archiving area of BallyAlley.com:
http://www.ballyalley.com/program_downloads/tape_archive_tools/tape_archive_tools.html

Or, if you prefer, here is a direct link to BallyBin/AstroWAV:
http://www.ballyalley.com/program_downloads/tape_archive_tools/ballybin/Astrowav%20and%20Ballybin%20(200x)(Bob%20Colbert).zip

Version 1.4 of BallyBin usually seems to process 2000-baud analog tape recordings best. The directions for BallyBin and AstroWAV 2 talk about how the "AstroBASIC" format works.

The 2000-baud program area of BallyAlley.com provides hundreds of 2000-baud programs in WAV format that can be downloaded. These programs have all been digitally archived using the BallyBin/AstroWAV combination of programs:
http://www.ballyalley.com/program_downloads/2000_baud_programs/2000_baud_programs.html

If RAW recordings (saved to .WAV) from original hardware are needed for implementations, I am available to provide such assistance. If any more information is required, then let me know what you need; I'll help you find what you're looking for related to "AstroBASIC."
Steps To Reproduce 2000-Baud support is completely missing, therefore, if you type :INPUT from "AstroBASIC," there is no way to load a program. Or course, programs also can not be saved using :PRINT.
Additional Information
Flags
Regression Version
Affected Sets / Systems astrocde and clones
Attached Files
jpg file icon Astro BASIC (Bally).jpg (407,791 bytes) Aug 9, 2018, 21:27 Uploaded by ballyalley
This is a picture of the tape interface included in the "AstroBASIC" cartridge.
ballyalley
Relationships
related to 06987Acknowledged astrocde and clones: [Enhancement] Best Way to Report Missing Vital Features? 
Notes
1
User avatar
No.15334
Haze
Senior Tester
Aug 13, 2018, 14:17
Assigning reports to people just for making them is being an asshole. Let's not be assholes.